local AvatarID, wtBar, wtText

function setPlacement( widget, place )
	local p = widget:GetPlacementPlain()
	for k, v in pairs(place) do
		p[k] = place[k] or v
	end
	widget:SetPlacementPlain(p)
end

function Will_Changed(p)
	if p.unitId==AvatarID then
		local will = unit.GetWill( p.unitId )
		wtText:SetVal("val",common.FormatInt( will, "%d" ))
		setPlacement(wtBar, {sizeX = 180 * will / 100})
	end
end

function Init()	
	AvatarID=avatar.GetId()
	common.RegisterEventHandler( Will_Changed, "EVENT_UNIT_WILL_CHANGED")
	local wtWillPanel=mainForm:GetChildChecked( "WillPanel", true )
	wtWillPanel:SetBackgroundColor({ r = 0; g = 0; b = 0; a = 0.7 })
	wtBar=wtWillPanel:GetChildChecked( "Bar", true )
	wtBar:SetBackgroundColor({ r = 1.0; g = 1.0; b = 0; a = 1.0 })
	wtText=wtWillPanel:GetChildChecked( "Text", true )
	Will_Changed({unitId=AvatarID})
end

common.RegisterEventHandler(Init, "EVENT_AVATAR_CREATED")
if avatar.IsExist() then
	Init()
end
